/* Copyright 2017
 * Neatu Darius-Florentin <neatudarius@gmail.com>
 */

#include <bits/stdc++.h>
#define oo (1LL << 60)
using namespace std;

int main() {
	FILE *in, *out;
	in = freopen("stropitori.in", "r", stdin);
	out = freopen("stropitori.out", "w", stdout);

	int n;
	int S;

	string line;
	getline(cin, line);

	cin >> n >> S;
	vector<int> x(n + 2);
	vector<long long> p(n + 2);

	for (int i = 1; i <= n; ++i) {
		scanf("%d", &x[i]);
		// cin >> x[i];
	}

	for (int i = 1; i <= n; ++i) {
		int power;

		scanf("%d", &power);
		// cin >> power;

		p[i] = power;
	}

	x[0] = -1;
	p[0] = 0;
	x[n + 1] = S + 1;
	p[n + 1] = 0;
	vector<int> left(n + 1), right(n + 1), stay(n + 1);

	for (int i = 1; i <= n; ++i) {
		stay[i] = max(stay[i - 1], left[i - 1]);
		if (x[i - 1] + p[i - 1] < x[i]) {
			stay[i] = max(stay[i], right[i - 1]);
		}

		left[i] = 0;
		if (x[i - 1] < x[i] - p[i]) {
			left[i] = max(1 + stay[i - 1], 1 + left[i - 1]);

			if (x[i - 1] + p[i - 1] < x[i] - p[i]) {
				left[i] = max(left[i], 1 + right[i - 1]);
			}
		}

		right[i] = 0;
		if (x[i] + p[i] < x[i + 1]) {
			right[i] = max(1 + stay[i - 1], 1 + left[i - 1]);

			if (x[i - 1] + p[i - 1] < x[i]) {
				right[i] = max(right[i], 1 + right[i - 1]);
			}
		}
	}

	int sol = max(stay[n], max(left[n], right[n]));

	cout << sol << '\n';

	fclose(in);
	fclose(out);

	return 0;
}
