/* Copyright 2017
 * Alex
 */

#include <ostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <iostream>
#include <fstream>
#include <cstring>

using namespace std;

#define LMAX 100
bool dp[LMAX][LMAX][LMAX][LMAX];


int main() {
	freopen("adn.in", "r", stdin);
	freopen("adn.out", "w", stdout);

	size_t test_count;
	cin >> test_count;

	for (auto test_idx = 0u; test_idx < test_count; ++test_idx) {
		size_t word_count = 0u;
		std::string word;
		std::string target;
		string word1 = "";
		string word2 = "";
		string word3 = "";
		string word4 = "";

		cin >> word_count;
		if (word_count >= 1) {
			cin >> word1;
		}

		if (word_count >= 2) {
			cin >> word2;
		}

		if (word_count >= 3) {
			cin >> word3;
		}

		if (word_count >= 4) {
			cin >> word4;
		}

		cin >> target;

		bool rasp = false;

		int w1 = word1.size();
		int w2 = word2.size();
		int w3 = word3.size();
		int w4 = word4.size();
		int t = target.size();

		if ((w1 + w2 + w3 + w4) != t)
			goto show_answer;

		dp[w1][w2][w3][w4] = ((w1 + w2 + w3 + w4) == t);

		for (w1 = word1.size(); w1 >= 0; w1--) {
			for (w2 = word2.size(); w2 >= 0; w2--) {
				for (w3 = word3.size(); w3 >= 0; w3--) {
					for (w4 = word4.size(); w4 >= 0; w4--) {
						if ((w1 + w2 + w3 + w4) != t) {
							dp[w1][w2][w3][w4] = false;
						}

						if (w1 < (signed)word1.size()
						    && word1[w1] == target[w1 + w2 + w3 + w4]) {
							dp[w1][w2][w3][w4] |= dp[w1 + 1][w2][w3][w4];
						}

						if (w2 < (signed)word2.size()
						    && word2[w2] == target[w1 + w2 + w3 + w4]) {
							dp[w1][w2][w3][w4] |= dp[w1][w2 + 1][w3][w4];
						}

						if (w3 < (signed)word3.size()
						    && word3[w3] == target[w1 + w2 + w3 + w4]) {
							dp[w1][w2][w3][w4] |= dp[w1][w2][w3 + 1][w4];
						}

						if (w4 < (signed)word4.size()
						    && word4[w4] == target[w1 + w2 + w3 + w4]) {
							dp[w1][w2][w3][w4] |= dp[w1][w2][w3][w4 + 1];
						}
					}
				}
			}
		}
		rasp = dp[0][0][0][0];
		show_answer:
		cout << rasp << "\n";
	}

	return 0;
}
