/* Copyright
 * Silviu
 */
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
	freopen("points.in", "r", stdin);
	freopen("points.out", "w", stdout);

	int n, m;

	cin >> n >> m;

	vector<int> points(n);
	vector<pair<int, int>> intervals(m);

	for (int i = 0; i < n; ++i) {
		// cin >> points[i];
		scanf("%d", &points[i]);
	}

	for (int i = 0; i < m; ++i) {
		// cin >> intervals[i].first >> intervals[i].second;
		scanf("%d%d", &intervals[i].first, &intervals[i].second);
	}

	sort(intervals.begin(), intervals.end());

	int ans = 0;
	int limit = -1;
	for (int i = 0, j = 0; i < (int)points.size(); ++i) {
		if (points[i] <= limit) {
			continue;
		}

		++ans;
		for (; j < (int)intervals.size(); ++j) {
			if (intervals[j].first > points[i]) {
				break;
			}

			if (intervals[j].second > limit) {
				limit = intervals[j].second;
			}
			// limit = max(limit, intervals[j].second);
		}
	}

	cout << ans << endl;

	return 0;
}
